/*-
 * Copyright (C)2003 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2003 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: copyarray.c,v 1.1 2003/11/16 04:47:18 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <sysexits.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "getCGIparm.h"

int
getCGIparmarray( u_int32_t flags
    , const u_char ** args
    , const u_char * const tofind
    , const u_char * const query_delimit
    , const u_char * const null_sign
    ) {
    u_char *p, *f1;
    int i, ex = EX_OK;
    const u_char *empty = "";

    if  (flags & gCGI_VERB)
        fprintf( stderr
               , "AR flags=%06X, tofind=%s~, query_delimit=%s~, null_sign=%s~\n"
               , flags
               , tofind ? tofind : empty
               , query_delimit
               , null_sign
               );
    f1 = NULL;

    for (i = 0; !ex && args && args[i]; i++) {
        p = args[i];
        if  (flags & gCGI_VERB) fprintf(stderr, "p=%s~\n", p);
        if  (!(ex = getCGIparmpass2(flags, tofind, p)) && ~flags & gCGI_OTST) {
            f1 = p;
            if  ((ex = getCGIparmpass3(flags, "copy", &p))) break;
            printf("%d%s", i, query_delimit);
            if  (flags & gCGI_RNUM) printf("%s%s", null_sign, query_delimit);
            printf("%s\n", p);
            if  (p && p != f1) {
                free(p);
                p = NULL;
    }   }   }
    if  (p && p != f1) free(p);
    if  (!ex) printf("\\.\n");
    if  (flags & gCGI_VERB) fprintf(stderr, "AR ex=%d\n", ex);
    return(ex);
}
